<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import { getDefaultSettings, validPlayerCounts } from "./settings";
  const dispatch = createEventDispatcher();

  export let settings: GameSettings = getDefaultSettings();

  let currentSettings = settings;

  let playerCounts = [...settings.playerCounts];

  $: if (settings !== currentSettings) {
    playerCounts = [...settings.playerCounts];
    currentSettings = settings;
  }

  export let readonly: boolean = false;

  function handleChange() {
    const newSettings = { playerCounts };
    dispatch("settings_change", newSettings);
  }
</script>

<section>
  <fieldset>
    <legend>Player counts</legend>

    <ul>
      {#each validPlayerCounts as c (c)}
        <li>
          <label class="player-count" for="player-count-{c}">
            <input
              id="player-count-{c}"
              type="checkbox"
              checked={playerCounts.includes(c)}
              bind:group={playerCounts}
              on:change={handleChange}
              value={c}
              disabled={readonly}
            />
            {c}
          </label>
        </li>
      {/each}
    </ul>
    <ul>
      <li><small>Recommended: 4-10</small></li>
      <li><small>Best: 5-6</small></li>
    </ul>
  </fieldset>
</section>

<style>
  section {
    padding-bottom: 1rem;
    display: grid;
    row-gap: 1em;
  }

  fieldset {
    border: 0;
    padding: 0;
    margin: 0;
  }
  legend {
    padding: 0;
  }
  ul {
    margin: 0;
    display: flex;
    flex-wrap: wrap;
    column-gap: 1em;
  }
  li {
    white-space: nowrap;
  }

  small {
    filter: opacity(90%);
  }
</style>
